#pragma once
#include <vector>
#include <vcg/point2.h>
#include <vcg/matrix44.h>
#include <QString.h>

namespace vcg {


class CICell 
{
public:
	bool selected;
	Point3f V[4];
	Point3f n;
	float tmpH[4];
	void ComputeNormal();
	void drawGL();
	float avgH() {return (V[0][2]+V[1][2]+V[2][2]+V[3][2])/4.0f;}

};


class CIGrid 
{
public:
	CIGrid() :ti(0){resize(10,10);}
	CIGrid(const int _sx, const int _sy) {resize(_sx,_sy);}
  GLuint ti;
	void setTexture(QString t) {texFileName=t;};
	void initGL();
	void resize(const int sx, const int sy)  ;
	inline CICell &G(const int i, const int j){return g[j*sx+i];}
	void drawGL();
	bool pickGL(Point2i in, Point2i &pos);
	bool pickGL(Point3d in, Point2i &pos);
  void clearSelection();
	void selectRect(Point2i s, Point2i e);
 void raiseSelected(float f);
 void smoothSelected();
 void flattenSelected();

private:
	std::vector<CICell> g;
	int sx,sy;
	QString texFileName;

	// for the picking
	double mm[16],mp[16];
	int vp[4]; // the viewport

};
};
